#ifndef _PHP_ORBIT_H
#define _PHP_ORBIT_H

#include "config.h"
#include "php_config.h"
#include "php.h"
#include "zend_compile.h"
#include "php_globals.h"
#include "phorb.h"

#ifdef PHP_WIN32
#define PHP_ORBIT_API   __declspec(dllexport)
#else
#define PHP_ORBIT_API
#endif

#if HAVE_ORBIT
#include <glib.h>
#include <orbit/orbit.h>

#ifdef ZTS
#include "TSRM.h"
#endif
#define PHP_ORBIT_VERSION	"0.2.0"
#define PHP_ORBIT_EXTNAME	"orbit"

extern zend_module_entry orbit_module_entry;

ZEND_BEGIN_MODULE_GLOBALS(orbit)
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	GHashTable		*idl_cache;
	GSList			*idls;
	long			idl_cache_timeout;
	long			idl_cache_check;
	char			*idl_cpp_arguments;
	char			*exception_handler;
	zval			*exception;
	int			exception_counter;
	int			active, counter;
ZEND_END_MODULE_GLOBALS(orbit)

#ifdef ZTS
# define OrbSG(v)	TSRMG(orbit_globals_id, zend_orbit_globals *, v)

extern int orbit_globals_id;
#else
# define OrbSG(v)	(orbit_globals.v)

extern zend_orbit_globals orbit_globals;
#endif

#define phpext_orbit_ptr	orbit_module_ptr

#else
#define phpext_orbit_ptr	NULL

#endif /* HAVE_ORBIT */

#endif
