<?php
//	dl('orbit.so');
	header('Content-Type: text/plain');

	function exception_handler($arg) {
		global $exception, $exception_self;

		if (substr($arg->_class, 0, 6) == "CORBA." && !$exception_self)
			die("\nCritical CORBA exception received: {$arg->text} ({$arg->status})\n");
		else
			$exception = $arg;
	}
	orbit_exception_handler('exception_handler');

	orbit_load_idl('Account.idl');

	$account = new CORBA(join('',file('account.ref')));

	for($i = 0; $i < 0; $i++)
		$account->deposit(1);

	$account->deposit(100);
	$account->deposit(100);
	$account->deposit(100);
	$account->deposit(100);
	$account->deposit(100/3);
	$account->withdraw(240);
	$account->withdraw(10);

	print "Balance is ".$account->balance()."\n";

	$prefs = $account->prefs;

	print "Favorite color is {$prefs->favorite_color}\n";
	print "Lottery numbers are ".join(' ',$prefs->lottery_numbers)."\n";
	print "Nickname is {$prefs->nickname}\n";

	$account->set_pref(array('pt_color','chartreuse'));
	$account->set_pref(array('pt_nickname','Grumpy'));

	$face = <<<FACE
  /****\  
 ;      ; 
 [ O  O ] 
 l   \  l 
  ; -- ;  
   ;;;;   
FACE;
/**/
	$lines = explode("\n", $face);
	$chars = array();
	for(reset($lines); $line = current($lines); next($lines)) {
		$charline = array();
		for($i = 0; $i < strlen($line); $i++)
			$charline[] = $line[$i];
		$chars[] = $charline;
	}
	$account->appearance = $chars;

	for($app = $account->appearance; $line = current($app); next($app))
		print join('',$line)."\n";

	$p = $account->get_pref('pt_color');
	print "Favorite color is now ".$p[1]."\n";

	$p = $account->get_pref_any('pt_color');
	print "As an any: favorite color is now ".$p[1]."\n";

	$p = $account->get_pref_any('pt_nickname');
	print "As an any: nickname is now ".$p[1]."\n";

	print "2 * 1,000,000,000 pennies = ".$account->add(1000000000,1000000000)." pennies\n";

	print "Withdrawing \$100,000\n";
	$account->withdraw(100000);

	if ($exception) {
		switch($exception->_class) {
			case 'Account.Account.InsufficientFunds':
				print "Oops. I don't have that much money\n";
				print "    (I need {$exception->overdraft} more)\n";
				break;
		}
		unset($exception);
	}

	$counter = $account->counter();

	$res = array();
	for($i = 1; $i <= 10; $i++)
		$res[] = $counter->next();
	print join(' ',$res)."\n";

	$counter->destroy();

	$exception_self = true;
	$counter->next();
	if ($exception) {
		switch($exception->_class) {
			default:
				print "Caught {$exception->_class} while counting with a destroyed counter\n";
		}
		unset($exception);
	}
	$exception_self = false;

	print "Successful completion\n";
?>
